Merge branch 'x86-debug-for-linus' of git://git.kernel.org/pub/scm/linux/kernel/git...
[sfrench/cifs-2.6.git] / scripts / faddr2line
1 #!/bin/bash
2 # SPDX-License-Identifier: GPL-2.0
3 #
4 # Translate stack dump function offsets.
5 #
6 # addr2line doesn't work with KASLR addresses.  This works similarly to
7 # addr2line, but instead takes the 'func+0x123' format as input:
8 #
9 #   $ ./scripts/faddr2line ~/k/vmlinux meminfo_proc_show+0x5/0x568
10 #   meminfo_proc_show+0x5/0x568:
11 #   meminfo_proc_show at fs/proc/meminfo.c:27
12 #
13 # If the address is part of an inlined function, the full inline call chain is
14 # printed:
15 #
16 #   $ ./scripts/faddr2line ~/k/vmlinux native_write_msr+0x6/0x27
17 #   native_write_msr+0x6/0x27:
18 #   arch_static_branch at arch/x86/include/asm/msr.h:121
19 #    (inlined by) static_key_false at include/linux/jump_label.h:125
20 #    (inlined by) native_write_msr at arch/x86/include/asm/msr.h:125
21 #
22 # The function size after the '/' in the input is optional, but recommended.
23 # It's used to help disambiguate any duplicate symbol names, which can occur
24 # rarely.  If the size is omitted for a duplicate symbol then it's possible for
25 # multiple code sites to be printed:
26 #
27 #   $ ./scripts/faddr2line ~/k/vmlinux raw_ioctl+0x5
28 #   raw_ioctl+0x5/0x20:
29 #   raw_ioctl at drivers/char/raw.c:122
30 #
31 #   raw_ioctl+0x5/0xb1:
32 #   raw_ioctl at net/ipv4/raw.c:876
33 #
34 # Multiple addresses can be specified on a single command line:
35 #
36 #   $ ./scripts/faddr2line ~/k/vmlinux type_show+0x10/45 free_reserved_area+0x90
37 #   type_show+0x10/0x2d:
38 #   type_show at drivers/video/backlight/backlight.c:213
39 #
40 #   free_reserved_area+0x90/0x123:
41 #   free_reserved_area at mm/page_alloc.c:6429 (discriminator 2)
42
43
44 set -o errexit
45 set -o nounset
46
47 command -v awk >/dev/null 2>&1 || die "awk isn't installed"
48 command -v readelf >/dev/null 2>&1 || die "readelf isn't installed"
49 command -v addr2line >/dev/null 2>&1 || die "addr2line isn't installed"
50
51 usage() {
52         echo "usage: faddr2line <object file> <func+offset> <func+offset>..." >&2
53         exit 1
54 }
55
56 warn() {
57         echo "$1" >&2
58 }
59
60 die() {
61         echo "ERROR: $1" >&2
62         exit 1
63 }
64
65 # Try to figure out the source directory prefix so we can remove it from the
66 # addr2line output.  HACK ALERT: This assumes that start_kernel() is in
67 # kernel/init.c!  This only works for vmlinux.  Otherwise it falls back to
68 # printing the absolute path.
69 find_dir_prefix() {
70         local objfile=$1
71
72         local start_kernel_addr=$(readelf -sW $objfile | awk '$8 == "start_kernel" {printf "0x%s", $2}')
73         [[ -z $start_kernel_addr ]] && return
74
75         local file_line=$(addr2line -e $objfile $start_kernel_addr)
76         [[ -z $file_line ]] && return
77
78         local prefix=${file_line%init/main.c:*}
79         if [[ -z $prefix ]] || [[ $prefix = $file_line ]]; then
80                 return
81         fi
82
83         DIR_PREFIX=$prefix
84         return 0
85 }
86
87 __faddr2line() {
88         local objfile=$1
89         local func_addr=$2
90         local dir_prefix=$3
91         local print_warnings=$4
92
93         local func=${func_addr%+*}
94         local offset=${func_addr#*+}
95         offset=${offset%/*}
96         local size=
97         [[ $func_addr =~ "/" ]] && size=${func_addr#*/}
98
99         if [[ -z $func ]] || [[ -z $offset ]] || [[ $func = $func_addr ]]; then
100                 warn "bad func+offset $func_addr"
101                 DONE=1
102                 return
103         fi
104
105         # Go through each of the object's symbols which match the func name.
106         # In rare cases there might be duplicates.
107         file_end=$(size -Ax $objfile | awk '$1 == ".text" {print $2}')
108         while read symbol; do
109                 local fields=($symbol)
110                 local sym_base=0x${fields[0]}
111                 local sym_type=${fields[1]}
112                 local sym_end=${fields[3]}
113
114                 # calculate the size
115                 local sym_size=$(($sym_end - $sym_base))
116                 if [[ -z $sym_size ]] || [[ $sym_size -le 0 ]]; then
117                         warn "bad symbol size: base: $sym_base end: $sym_end"
118                         DONE=1
119                         return
120                 fi
121                 sym_size=0x$(printf %x $sym_size)
122
123                 # calculate the address
124                 local addr=$(($sym_base + $offset))
125                 if [[ -z $addr ]] || [[ $addr = 0 ]]; then
126                         warn "bad address: $sym_base + $offset"
127                         DONE=1
128                         return
129                 fi
130                 addr=0x$(printf %x $addr)
131
132                 # weed out non-function symbols
133                 if [[ $sym_type != t ]] && [[ $sym_type != T ]]; then
134                         [[ $print_warnings = 1 ]] &&
135                                 echo "skipping $func address at $addr due to non-function symbol of type '$sym_type'"
136                         continue
137                 fi
138
139                 # if the user provided a size, make sure it matches the symbol's size
140                 if [[ -n $size ]] && [[ $size -ne $sym_size ]]; then
141                         [[ $print_warnings = 1 ]] &&
142                                 echo "skipping $func address at $addr due to size mismatch ($size != $sym_size)"
143                         continue;
144                 fi
145
146                 # make sure the provided offset is within the symbol's range
147                 if [[ $offset -gt $sym_size ]]; then
148                         [[ $print_warnings = 1 ]] &&
149                                 echo "skipping $func address at $addr due to size mismatch ($offset > $sym_size)"
150                         continue
151                 fi
152
153                 # separate multiple entries with a blank line
154                 [[ $FIRST = 0 ]] && echo
155                 FIRST=0
156
157                 # pass real address to addr2line
158                 echo "$func+$offset/$sym_size:"
159                 addr2line -fpie $objfile $addr | sed "s; $dir_prefix\(\./\)*; ;"
160                 DONE=1
161
162         done < <(nm -n $objfile | awk -v fn=$func -v end=$file_end '$3 == fn { found=1; line=$0; start=$1; next } found == 1 { found=0; print line, "0x"$1 } END {if (found == 1) print line, end; }')
163 }
164
165 [[ $# -lt 2 ]] && usage
166
167 objfile=$1
168 [[ ! -f $objfile ]] && die "can't find objfile $objfile"
169 shift
170
171 DIR_PREFIX=supercalifragilisticexpialidocious
172 find_dir_prefix $objfile
173
174 FIRST=1
175 while [[ $# -gt 0 ]]; do
176         func_addr=$1
177         shift
178
179         # print any matches found
180         DONE=0
181         __faddr2line $objfile $func_addr $DIR_PREFIX 0
182
183         # if no match was found, print warnings
184         if [[ $DONE = 0 ]]; then
185                 __faddr2line $objfile $func_addr $DIR_PREFIX 1
186                 warn "no match for $func_addr"
187         fi
188 done